
#include "fmf.h"

#define FMF_TAG 0x5F464D46

typedef struct tag_FMFHeader {
	DWORD	dwIdentifier;	// t@Cʎq 'FMF_'
	DWORD	dwSize;			// wb_f[^TCY
	DWORD	dwWidth;		// }bv̉
	DWORD	dwHeight;		// }bv̍
	BYTE	byChipWidth;	// }bv`bv1̕(pixel)
	BYTE	byChipHeight;	// }bv`bvP̍(pixel)
	BYTE	byLayerCount;	// C[̐
	BYTE	byBitCount;		// Cf[^̃rbgJEg
} FMFHEADER;

//-----------------------------------------------------------------------------
// Plugin̏ݒ肷
//
// 
// pPluginInfo	: vOC̏ݒ肷\̂̃|C^
//
// ߂l
// Ȃ
//-----------------------------------------------------------------------------
EXPORT void GetPlatinumPluginInfo(PlatinumPluginInfo* pPluginInfo)
{
	// AoEg{bNXɕ\vOC̖O
	strncpy(pPluginInfo->szPluginName, "Fixed Mapdata File Import/Export Plugin 2005 (c) HyperDevice Software", 128);

	// t@CI_CAO{bNX́ut@C̎ށvɃXgtB^
	// gq𕡐w肷ꍇ;ŋ؂Ă@Fixed Mapdata File (*.fmf;*.fmm)|*.fmf;*.fmm@Ȃ
	// 1̃vOCŕ̃tB^͎wo܂
	strncpy(pPluginInfo->szFileFilter, "Fixed Mapdata File (*.fmf)|*.fmf", 128);

	// vOC̓\tO
	// ̏ꍇt@Cj[́uǂݍ݁vuovJt@CI_CAO
	// ̃vOCI\ɂȂ
	pPluginInfo->dwFlags = PPITYPE_IMPORT | PPITYPE_EXPORT;
}

//-----------------------------------------------------------------------------
// ǂݍ݉\ȃt@CȂ̂𒲂ׂĂ̌ʂԂ
// lŎg悤ȃvOC̏ꍇ͊gq̃`FbNłǂ
// t@C̓emFȂꍇ͍ŒAgq̃`FbN͂ĉ
//
// 
// lpszFileName		: Iꂽt@C̃tpX
//
// ߂l
// ǂݍ݉\		: PPIRET_OK
// ǂݍݕs\	: PPIRET_UNSUPPORTED
//-----------------------------------------------------------------------------
EXPORT int IsSupported(LPCTSTR lpszFilePath)
{
	HANDLE hFile;
	hFile = CreateFile(	lpszFilePath, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		return PPIRET_UNSUPPORTED;
	}
	
	DWORD dwIdentifier;
	DWORD dwWriteBytes;
	if (!ReadFile(hFile, &dwIdentifier, sizeof(DWORD), &dwWriteBytes, NULL) ||
		dwWriteBytes != sizeof(DWORD))
	{
		CloseHandle(hFile);
		return PPIRET_UNSUPPORTED;
	}

	CloseHandle(hFile);

	return dwIdentifier == FMF_TAG ? PPIRET_OK : PPIRET_UNSUPPORTED;
}

//-----------------------------------------------------------------------------
// t@C֏o
//
// 
// hWndParent	: PlatinumCEBhẼEBhEnhB
// lpszFilePath	: Iꂽt@C̃tpXB
// pData		: PlatinumǗf[^\̂̃|C^B̃f[^t@Cɏ݂܂B
// fnCallback	: vOXo[XV邽߂̃R[obN֐B
// 				  fnCallback(݂̃Xebv, Xebv, bZ[W);
//
// ߂l
// I		: PPIRET_OK
// ̒f	: PPIRET_ABORT
// ̑G[	: PPIRET_``
//-----------------------------------------------------------------------------
EXPORT int Export(HWND hWndParent, LPCTSTR lpszFilePath, const PlatinumData* pData, PPI_PROGRESS_CALLBACK fnCallback)
{
	if (hWndParent == NULL || lpszFilePath == NULL || pData == NULL || fnCallback == NULL)
		return PPIRET_INVALIDPARAMS;

	DWORD dwLayerSize = pData->important.header.dwMapWidth *
						pData->important.header.dwMapHeight *
						pData->important.header.byBitCount / 8;

	// FMFt@C̃wb_p
	FMFHEADER fmfHeader;
	fmfHeader.dwIdentifier	= FMF_TAG;
	fmfHeader.dwSize		= dwLayerSize * pData->important.header.byLayerCount;
	fmfHeader.dwWidth		= pData->important.header.dwMapWidth;
	fmfHeader.dwHeight		= pData->important.header.dwMapHeight;
	fmfHeader.byChipWidth	= (BYTE)pData->important.header.dwChipWidth;
	fmfHeader.byChipHeight	= (BYTE)pData->important.header.dwChipHeight;
	fmfHeader.byLayerCount	= pData->important.header.byLayerCount;
	fmfHeader.byBitCount	= pData->important.header.byBitCount;

	// t@C쐬
	HANDLE hFile;
	hFile = CreateFile(	lpszFilePath, GENERIC_WRITE, FILE_SHARE_READ, NULL,
						CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		return PPIRET_FILEERR;
	}

	// wb_̏
	DWORD dwWriteBytes;
	if (!WriteFile(hFile, &fmfHeader, sizeof(FMFHEADER), &dwWriteBytes, NULL) ||
		dwWriteBytes != sizeof(FMFHEADER))
	{
		CloseHandle(hFile);
		return PPIRET_FILEERR;
	}

	// C[
	DWORD dwWriteSize = fmfHeader.byBitCount / 8;
	for (BYTE i = 0; i < fmfHeader.byLayerCount; i++)
	{
		// f[^̏
		for (DWORD k = 0; k < fmfHeader.dwWidth * fmfHeader.dwHeight; k++)
		{
			if (!WriteFile(hFile, &pData->important.pLayers[i].pData[k], dwWriteSize, &dwWriteBytes, NULL) || 
				dwWriteBytes != dwWriteSize)
			{
				CloseHandle(hFile);
				return PPIRET_FILEERR;
			}
		}

		// vOXo[̍XV
		if (fnCallback(i, fmfHeader.byLayerCount, "writing...") == PPICALLBACK_ABORT)
		{
			CloseHandle(hFile);
			return PPIRET_ABORT;
		}
	}

	CloseHandle(hFile);
	return PPIRET_OK;
}

#define ABORT(ret) \
{ \
	for (int i = 0; i < pData->important.header.byLayerCount; i++) \
	{ \
		SAFE_GLOBAL_FREE(pData->important.pLayers[i].lpszLayerName); \
		SAFE_GLOBAL_FREE(pData->important.pLayers[i].lpszLayerChipName); \
		SAFE_GLOBAL_FREE(pData->important.pLayers[i].pData); \
	} \
	SAFE_GLOBAL_FREE(pData->important.pLayers); \
	SAFE_GLOBAL_FREE(pData->optional.lpszComment); \
	SAFE_GLOBAL_FREE(pData->optional.hidden.pData); \
	return ret; \
}

//-----------------------------------------------------------------------------
// t@C̓ǂݍ
//
// 
// hWndParent	: PlatinumCEBhẼEBhEnhB
// lpszFilePath	: Iꂽt@C̃tpXB
// pData		: PlatinumǗf[^\̂̃|C^B̃f[^t@Cɏ݂܂B
// fnCallback	: vOXo[XV邽߂̃R[obN֐B
// 				  fnCallback(݂̃Xebv, Xebv, bZ[W);
//
// ߂l
// I		: PPIRET_OK
// ̒f	: PPIRET_ABORT
// ̑G[	: PPIRET_``
//
// l
// pData->important.pLayers ͊eC[i[PlatinumData::Layer^̔zւ̃|C^łB
// GlobalAlloc(GPTR...)gpđSẴC[܂TCY̔zmۂ܂B
// pData->important.pLayers[n]->pData WORD^̔z̃|C^łB
// GlobalAlloc(GPTR...)gpăf[^܂TCY1zmۂĂB
// eC̃f[^z̃TCŶ͎悤ɌvZ܂B
// nSize =	pData->important.header.dwMapWidth *
// 			pData->important.header.dwMapHeight *
// 			sizeof(WORD);
//-----------------------------------------------------------------------------
EXPORT int Import(HWND hWndParent, LPCTSTR lpszFilePath, PlatinumData* pData, PPI_PROGRESS_CALLBACK fnCallback)
{
	if (hWndParent == NULL || lpszFilePath == NULL || pData == NULL || fnCallback == NULL)
		return PPIRET_INVALIDPARAMS;

	// t@CJ
	HANDLE hFile;
	hFile = CreateFile(	lpszFilePath, GENERIC_READ, FILE_SHARE_READ, NULL,
						OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		CloseHandle(hFile);
		return PPIRET_FILEERR;
	}

	// wb_[ǂݍŎʎqmF
	DWORD dwReadBytes;
	FMFHEADER fmfHeader;
	if (!ReadFile(hFile, &fmfHeader, sizeof(FMFHEADER), &dwReadBytes, NULL) ||
		dwReadBytes != sizeof(FMFHEADER))
	{
		CloseHandle(hFile);
		return PPIRET_INVALIDFILE;
	}
	if (memcmp(&fmfHeader.dwIdentifier, "FMF_", sizeof(DWORD)) != 0)
	{
		CloseHandle(hFile);
		return PPIRET_UNSUPPORTED;
	}

	// Â`FMFt@C(8bitp[c)łbyBitCountɂ͎̈gĂ炸A
	// Dirty bit(0xff)i[Ă̂łɑΉĂ
	if (fmfHeader.byBitCount == 255)
		fmfHeader.byBitCount = 8;

	// C[zm
	pData->important.pLayers = (PlatinumData::Important::Layer*)GlobalAlloc(GPTR, sizeof(PlatinumData::Important::Layer) * fmfHeader.byLayerCount);
	if (pData->important.pLayers == NULL)
	{
		CloseHandle(hFile);
		return PPIRET_OUTOFMEMORY;
	}

	// eC[̏
	for (BYTE i = 0; i < fmfHeader.byLayerCount; i++)
	{
		// f[^zm
		// t@C`Ɋ֌WȂPlatinum̃f[^zWORDzȂ̂
		// sizeof(WORD)PʂŃmۂ܂B
		DWORD dwArraySize = fmfHeader.dwWidth * fmfHeader.dwHeight * sizeof(WORD);
		pData->important.pLayers[i].pData = (WORD*)GlobalAlloc(GPTR, dwArraySize);
		if (pData->important.pLayers[i].pData == NULL)
		{
			CloseHandle(hFile);
			ABORT(PPIRET_OUTOFMEMORY);
		}

		// f[^ǂ
		DWORD dwReadSize = fmfHeader.byBitCount / 8;
		for (DWORD k = 0; k < fmfHeader.dwWidth * fmfHeader.dwHeight; k++)
		{
			if (!ReadFile(hFile, &pData->important.pLayers[i].pData[k], dwReadSize, &dwReadBytes, NULL) ||
				dwReadBytes != dwReadSize)
			{
				CloseHandle(hFile);
				ABORT(PPIRET_INVALIDFILE);
			}
		}
		pData->important.pLayers[i].byVisible = 1;

		// vOXo[XV
		if (fnCallback(i, fmfHeader.byLayerCount, "reading...") == PPICALLBACK_ABORT)
		{
			CloseHandle(hFile);
			ABORT(PPIRET_ABORT);
		}
	}

	// wb_
	pData->important.header.dwMapWidth		= fmfHeader.dwWidth;
	pData->important.header.dwMapHeight		= fmfHeader.dwHeight;
	pData->important.header.dwChipWidth		= fmfHeader.byChipWidth;
	pData->important.header.dwChipHeight	= fmfHeader.byChipHeight;
	pData->important.header.byBitCount		= fmfHeader.byBitCount;
	pData->important.header.byLayerCount	= fmfHeader.byLayerCount;
	pData->important.header.byRelativePath	= 0;
	pData->important.header.reserved		= 0;

	CloseHandle(hFile);
	return PPIRET_OK;
}






